#include <iostream>
using namespace std;
// vytvorime datovy kontejner pole a pak ho naplnime

template <typename T>	//sablona objektu pole, T je datovy typ, ktey v kodu urcime (zde v mainu pri deklaraci promenne pole)
class pole
{
private:
	T * m_data;	// promenna m_data je ukazatel na T
	int m_delka;
public:
	// konstruktor
	pole(int delka=10):m_data(new T [delka]),
		 	   m_delka(delka)
	{}

	// kopirujici konstruktor - kopie celeho pole (velikost i prvky)
	pole(const pole & zdroj):m_data(new T [zdroj.m_delka]),
				 m_delka (zdroj.m_delka)	
	{
		for(int i=0;i<m_delka;i++) m_data[i]=zdroj.m_data[i];
	}

	//destruktor
	~pole(void)
	{
		delete [] m_data;
	}

	//definice operatoru []
	T & operator [] (int pozice) const
	// & - vracime referenci (adresu) na m_data[pozice], v programu, kam vracime hodnotu m_data[pozice], muzeme tuto hodnotu menit (protoze vracime referenci),
	// const - po dobu vykonavani teto metody zustane hodnota celeho objektu pole konstatni
	{
		if((pozice>=m_delka)||(pozice<0)) throw "Neplatny index!"; // retezec je zachycen v mainu do chyba a nasledne vypsan
		return m_data[pozice];
	}

	//definice operatoru =
	pole & operator = (const pole & zdroj)
	{
		if(this==&zdroj) return *this; 
		//vraci aktualni pole, zapis this==&zdroj znamena porovnavani adres, ty jsou totozne pouze v pripade, kdy se jedna o totozny objekt
		delete []m_data;	
		// [] znamena vsechny prvky
		m_delka=zdroj.m_delka;
		m_data=new T [m_delka];	
		//alokace pameti
		for(int i=0;i<m_delka;i++) m_data[i]=zdroj.m_data[i];
		return * this;
		// this je ukazatel na objekt, se kterym prave pracujeme - vrati cely objekt
	}
	
	pole & zvetsenipole(int novavelikost) // metoda zvetseni pole vraci referenci na pole
	//zvetseni pole -  v C++ nelze zvetsit - neni realoc!, vytvorime nove a do neho zkopirujeme stare
	{
		if (novavelikost<=m_delka) return *this; //vrati se nezmeneny objekt - nelze zvetsovat na mensi
		T * novepole=new T [novavelikost];
		for(int i=0;i<m_delka;i++) novepole[i]=m_data[i];
		m_delka=novavelikost;
		delete [] m_data; // smaze puvodni pole, od adresy prvniho rvku pole, [] znamena vsechny prvky
		m_data=novepole; // do m_data se vlozi adresa noveho pole
		return *this;
	}
};

int main (void)
{
	try
	{
		pole <int> K(20); // K je typu pole, <int> je pozadevek na pole integeru
		// K[30]=0; vyvola chybu
		for(int i=0;i<20;i++) K[i]=i;
		for(int i=0;i<20;i++) cout<<K[i]<<", ";
		cout<<endl;
		pole <char> L(20); // L je typu pole, <char> je pozadevek na pole znaku
		for(int i=0;i<20;i++) L[i]=i+'0'; //´0´ do pole vlozime znaky, ktere jsou v ASCII od pozice znaku 0
		for(int i=0;i<20;i++) cout<<L[i]<<", ";
		cout<<endl;	
	}
	catch(const char * chyba)
	{
		cout << chyba << endl;
	}
	return 0;
}
